<template>
  <div>
    <!--引用表格-->
   <BasicTable @register="registerTable" :rowSelection="rowSelection">
     <!--插槽:table标题-->
      <template #tableTitle>
          <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新增</a-button>
          <a-button  type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
          <j-upload-button  type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
          <a-dropdown v-if="selectedRowKeys.length > 0">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined"></Icon>
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button>批量操作
                <Icon icon="mdi:chevron-down"></Icon>
              </a-button>
        </a-dropdown>
      </template>
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <WbCompanyInfoModal @register="registerModal" @success="handleSuccess"></WbCompanyInfoModal>

    <a-drawer
        :title="pullDrawerTitle"
        placement="right"
        width="60%"
        :closable="true"
        :visible="showApiDrawer"
        :get-container="false"
        :wrap-style="{ position: 'absolute'}"
        @close="closePullDataDrawer"
        :body-style="{ padding: '0px' }"
    >
    <WbThirdApiList ref="refWbThirdApiList"></WbThirdApiList>
    </a-drawer>

    <a-drawer
        :title="detailDrawerTitle"
        placement="right"
        width="70%"
        :closable="true"
        :visible="showDetailDrawer"
        :get-container="false"
        @close="closeDetailDrawer"
        :body-style="{ padding: '0px',margin:'0px' }"
    >
    <WbCompanyDetail  ref="refWbCompanyDetail"></WbCompanyDetail>
    </a-drawer>
  </div>
</template>

<script lang="ts" name="wb.manage-wbCompanyInfo" setup>
  import {ref, computed, unref} from 'vue';
  import {BasicTable, useTable, TableAction} from '/@/components/Table';
  import {useModal} from '/@/components/Modal';
  import { useListPage } from '/@/hooks/system/useListPage'
  import WbCompanyInfoModal from './components/WbCompanyInfoModal.vue'
  import WbThirdApiList from './components/WbThirdApiList.vue'

  import WbCompanyDetail from './components/WbCompanyDetail.vue'
  
  
  import {columns, searchFormSchema} from './WbCompanyInfo.data';
  import {list, deleteOne, batchDelete, getImportUrl,getExportUrl} from './WbCompanyInfo.api';
  import { useDrawer } from '/@/components/Drawer';
  const [registerDrawer, { openDrawer }] = useDrawer();

  const showApiDrawer =ref(false)
  const showDetailDrawer = ref(false)

  const refWbCompanyDetail =ref()
  const refWbThirdApiList = ref()
  const pullDrawerTitle= ref("");
  const detailDrawerTitle = ref("")

  //注册model
  const [registerModal, {openModal}] = useModal();
  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: 'wb_company_info',
           api: list,
           columns,
           canResize:false,
           formConfig: {
              //labelWidth: 120,
              schemas: searchFormSchema,
              autoSubmitOnEnter:true,
              showAdvancedButton:true,
              fieldMapToNumber: [
              ],
              fieldMapToTime: [
              ],
            },
           actionColumn: {
               width: 150,
               fixed:'right'
            },
      },
      exportConfig: {
        name:"公司信息",
        url: getExportUrl,
      },
      importConfig: {
        url: getImportUrl,
        success: handleSuccess
      },
  })

  const [registerTable, {reload},{ rowSelection, selectedRowKeys }] = tableContext

  function handleAdd() {
     openModal(true, {
       isUpdate: false,
       showFooter: true,
     });
  }
 
  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
   
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }

  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
 
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
 
  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
   }

  function getTableAction(record){

      return [
        {
          label: '编辑',
          onClick: handleEdit.bind(null, record),
        },
        {
           label: '调查',
           onClick: handleShowPullData.bind(null, record)
        },
        {
           label: '查看',
           onClick: handleShowDetailDrawer.bind(null, record)
        }
      ]
   }

  function getDropDownAction(record){
       return [
         {
           label: '详情',
           onClick: handleDetail.bind(null, record),
         }, {
           label: '删除',
           popConfirm: {
             title: '是否确认删除',
             confirm: handleDelete.bind(null, record),
           }
         }
       ]
   }

  function handleShowPullData(record: Recordable){
    showApiDrawer.value = true
    pullDrawerTitle.value = "抓取【"+record.name+"】数据"
    refWbThirdApiList.value.setCompanyInfo(record);

  }


  async function handleShowDetailDrawer(record: Recordable){
    showDetailDrawer.value =true
    detailDrawerTitle.value = "【"+record.name+"】详细信息"
    refWbCompanyDetail.value.setCompanyInfo(record);

  }

  function closePullDataDrawer(){
    showApiDrawer.value = false
  }

  function closeDetailDrawer(){
    showDetailDrawer.value = false
  }


  
</script>

<style scoped>

</style>

